n = 0:511;

x = 0.25*n;
x = sin(pi*n/25);
x= sinc(0.1*pi*n);

%% filter white noise sequence
w = randn(1,512);
b = [1];
a = [1, -1.94, 0.96]

x = filter(b,a,w);

%% music


%Noise probability
Ps = 0.1;

%Filter length
K = 5;

%Noisy signal
xn = impulse_noise(x, Ps);

%just the noise
nu = xn-x;

%Mean filtering
y_mean = mean1(xn, K);

y_median = mfilt1(xn, K);

%% Compute SNR
SNR_in = 10*log10(sigEnergy(x)/sigEnergy(nu))
SNR_out_mean = 10*log10(sigEnergy(x)/sigEnergy(y_mean-x))
SNR_out_median = 10*log10(sigEnergy(x)/sigEnergy(y_median-x))

%% Plot everything
figure, hold on, grid on
plot(n, x, 'b')
plot(n, xn, 'k--')

plot(n, y_mean, 'r')
plot(n, y_median, 'g')

legend('x[n]', 'x_n[n]', 'y_{mean}[n]', 'y_{median}[n]')
xlim([min(n) max(n)])
xlabel('n')